Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 91218)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 91219)
@@ -1414,53 +1414,4 @@
 }
 
-void UIMessageCenter::cannotAcquireHardDiskLocation(const CMedium &comMedium, QWidget *pParent /* = 0 */) const
-{
-    /* Show the error: */
-    error(pParent, MessageType_Error,
-          tr("Failed to acquire hard disk location."), UIErrorString::formatErrorInfo(comMedium));
-}
-
-void UIMessageCenter::cannotDeleteHardDiskStorage(const CMedium &medium, const QString &strLocation, QWidget *pParent /* = 0*/) const
-{
-    error(pParent, MessageType_Error,
-          tr("Failed to delete the storage unit of the hard disk <b>%1</b>.")
-             .arg(strLocation),
-          UIErrorString::formatErrorInfo(medium));
-}
-
-void UIMessageCenter::cannotDeleteHardDiskStorage(const CProgress &progress, const QString &strLocation, QWidget *pParent /* = 0*/) const
-{
-    error(pParent, MessageType_Error,
-          tr("Failed to delete the storage unit of the hard disk <b>%1</b>.")
-             .arg(strLocation),
-          UIErrorString::formatErrorInfo(progress));
-}
-
-void UIMessageCenter::cannotTakeSnapshot(const CMachine &machine, const QString &strMachineName, QWidget *pParent /* = 0*/) const
-{
-    error(pParent, MessageType_Error,
-          tr("Failed to create a snapshot of the virtual machine <b>%1</b>.")
-             .arg(strMachineName),
-          UIErrorString::formatErrorInfo(machine));
-}
-
-void UIMessageCenter::cannotTakeSnapshot(const CProgress &progress, const QString &strMachineName, QWidget *pParent /* = 0*/) const
-{
-    error(pParent, MessageType_Error,
-          tr("Failed to create a snapshot of the virtual machine <b>%1</b>.")
-             .arg(strMachineName),
-          UIErrorString::formatErrorInfo(progress));
-}
-
-void UIMessageCenter::cannotFindSnapshotByName(const CMachine &comMachine,
-                                               const QString &strName,
-                                               QWidget *pParent /* = 0 */) const
-{
-    error(pParent, MessageType_Error,
-          tr("Can't find snapshot named <b>%1</b>.")
-             .arg(strName),
-          UIErrorString::formatErrorInfo(comMachine));
-}
-
 void UIMessageCenter::cannotAcquireCloudProviderManager(const CVirtualBox &comVBox, QWidget *pParent /* = 0 */) const
 {
@@ -2051,4 +2002,53 @@
 }
 
+void UIMessageCenter::cannotAcquireHardDiskLocation(const CMedium &comMedium, QWidget *pParent /* = 0 */) const
+{
+    /* Show the error: */
+    error(pParent, MessageType_Error,
+          tr("Failed to acquire hard disk location."), UIErrorString::formatErrorInfo(comMedium));
+}
+
+void UIMessageCenter::cannotDeleteHardDiskStorage(const CMedium &medium, const QString &strLocation, QWidget *pParent /* = 0*/) const
+{
+    error(pParent, MessageType_Error,
+          tr("Failed to delete the storage unit of the hard disk <b>%1</b>.")
+             .arg(strLocation),
+          UIErrorString::formatErrorInfo(medium));
+}
+
+void UIMessageCenter::cannotDeleteHardDiskStorage(const CProgress &progress, const QString &strLocation, QWidget *pParent /* = 0*/) const
+{
+    error(pParent, MessageType_Error,
+          tr("Failed to delete the storage unit of the hard disk <b>%1</b>.")
+             .arg(strLocation),
+          UIErrorString::formatErrorInfo(progress));
+}
+
+void UIMessageCenter::cannotTakeSnapshot(const CMachine &machine, const QString &strMachineName, QWidget *pParent /* = 0*/) const
+{
+    error(pParent, MessageType_Error,
+          tr("Failed to create a snapshot of the virtual machine <b>%1</b>.")
+             .arg(strMachineName),
+          UIErrorString::formatErrorInfo(machine));
+}
+
+void UIMessageCenter::cannotTakeSnapshot(const CProgress &progress, const QString &strMachineName, QWidget *pParent /* = 0*/) const
+{
+    error(pParent, MessageType_Error,
+          tr("Failed to create a snapshot of the virtual machine <b>%1</b>.")
+             .arg(strMachineName),
+          UIErrorString::formatErrorInfo(progress));
+}
+
+void UIMessageCenter::cannotFindSnapshotByName(const CMachine &comMachine,
+                                               const QString &strName,
+                                               QWidget *pParent /* = 0 */) const
+{
+    error(pParent, MessageType_Error,
+          tr("Can't find snapshot named <b>%1</b>.")
+             .arg(strName),
+          UIErrorString::formatErrorInfo(comMachine));
+}
+
 void UIMessageCenter::cannotCreateMachine(const CVirtualBox &vbox, QWidget *pParent /* = 0*/) const
 {
@@ -2338,31 +2338,4 @@
                               QString() /* cancel button text */,
                               false /* ok button by default? */);
-    else
-        return true;
-}
-
-bool UIMessageCenter::confirmOverridingFileIfExists(const QString &strPath, QWidget *pParent /* = 0*/) const
-{
-    QFileInfo fi(strPath);
-    if (fi.exists())
-        return confirmOverridingFile(strPath, pParent);
-    else
-        return true;
-}
-
-bool UIMessageCenter::confirmOverridingFilesIfExists(const QVector<QString> &strPaths, QWidget *pParent /* = 0*/) const
-{
-    QVector<QString> existingFiles;
-    foreach(const QString &file, strPaths)
-    {
-        QFileInfo fi(file);
-        if (fi.exists())
-            existingFiles << fi.absoluteFilePath();
-    }
-    /* If it is only one file use the single question versions above: */
-    if (existingFiles.size() == 1)
-        return confirmOverridingFileIfExists(existingFiles.at(0), pParent);
-    else if (existingFiles.size() > 1)
-        return confirmOverridingFiles(existingFiles, pParent);
     else
         return true;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 91218)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 91219)
@@ -375,18 +375,4 @@
     /** @} */
 
-    /** @name VirtualBox Manager / New VM wizard warnings.
-      * @{ */
-        void cannotAcquireHardDiskLocation(const CMedium &comMedium, QWidget *pParent = 0) const;
-        void cannotDeleteHardDiskStorage(const CMedium &medium, const QString &strLocation, QWidget *pParent = 0) const;
-        void cannotDeleteHardDiskStorage(const CProgress &progress, const QString &strLocation, QWidget *pParent = 0) const;
-    /** @} */
-
-    /** @name VirtualBox Manager / Clone VM wizard warnings.
-      * @{ */
-        void cannotTakeSnapshot(const CMachine &machine, const QString &strMachineName, QWidget *pParent = 0) const;
-        void cannotTakeSnapshot(const CProgress &progress, const QString &strMachineName, QWidget *pParent = 0) const;
-        void cannotFindSnapshotByName(const CMachine &comMachine, const QString &strName, QWidget *pParent = 0) const;
-    /** @} */
-
     /** @name VirtualBox Manager / Cloud networking warnings.
       * @{ */
@@ -464,43 +450,48 @@
     /** @} */
 
-    /* API: Wizards warnings: */
-    bool confirmHardDisklessMachine(QWidget *pParent = 0) const;
-    void cannotCreateMachine(const CVirtualBox &vbox, QWidget *pParent = 0) const;
-    void cannotRegisterMachine(const CVirtualBox &vbox, const QString &strMachineName, QWidget *pParent = 0) const;
-    void cannotOverwriteHardDiskStorage(const QString &strLocation, QWidget *pParent = 0) const;
-    void cannotCreateHardDiskStorage(const CVirtualBox &vbox, const QString &strLocation,QWidget *pParent = 0) const;
-    void cannotCreateHardDiskStorage(const CMedium &medium, const QString &strLocation, QWidget *pParent = 0) const;
-    void cannotCreateHardDiskStorage(const CProgress &progress, const QString &strLocation, QWidget *pParent = 0) const;
-    void cannotCreateHardDiskStorageInFAT(const QString &strLocation, QWidget *pParent = 0) const;
-    void cannotCreateMediumStorage(const CVirtualBox &comVBox, const QString &strLocation, QWidget *pParent = 0) const;
-    void cannotCreateMediumStorage(const CMedium &comMedium, const QString &strLocation, QWidget *pParent = 0) const;
-    void cannotCreateMediumStorage(const CProgress &comProgress, const QString &strLocation, QWidget *pParent = 0) const;
-    void cannotRemoveMachineFolder(const QString &strFolderName, QWidget *pParent = 0) const;
-    void cannotRewriteMachineFolder(const QString &strFolderName, QWidget *pParent = 0) const;
-    void cannotCreateMachineFolder(const QString &strFolderName, QWidget *pParent = 0) const;
-    void cannotCreateAppliance(const CVirtualBox &comVBox, QWidget *pParent = 0) const;
-    void cannotCreateVirtualSystemDescription(const CAppliance &comAppliance, QWidget *pParent = 0) const;
-    void cannotAcquireVirtualSystemDescription(const CAppliance &comAppliance, QWidget *pParent = 0) const;
-    void cannotAddVirtualSystemDescriptionValue(const CVirtualSystemDescription &comDescription, QWidget *pParent = 0) const;
-    void cannotAcquireVirtualSystemDescriptionFormProperty(const CVirtualSystemDescriptionForm &comForm, QWidget *pParent = 0) const;
-    void cannotImportAppliance(CAppliance &appliance, QWidget *pParent = 0) const;
-    void cannotImportAppliance(const CProgress &progress, const QString &strPath, QWidget *pParent = 0) const;
-    bool cannotCheckFiles(const CAppliance &comAppliance, QWidget *pParent = 0) const;
-    bool cannotCheckFiles(const CVFSExplorer &comVFSExplorer, QWidget *pParent = 0) const;
-    bool cannotCheckFiles(const CProgress &comProgress, QWidget *pParent = 0) const;
-    bool cannotRemoveFiles(const CVFSExplorer &comVFSExplorer, QWidget *pParent = 0) const;
-    bool cannotRemoveFiles(const CProgress &comProgress, QWidget *pParent = 0) const;
-    bool confirmExportMachinesInSaveState(const QStringList &machineNames, QWidget *pParent = 0) const;
-    bool cannotExportAppliance(const CAppliance &comAppliance, QWidget *pParent = 0) const;
-    void cannotExportAppliance(const CMachine &machine, const QString &strPath, QWidget *pParent = 0) const;
-    bool cannotExportAppliance(const CProgress &comProgress, const QString &strPath, QWidget *pParent = 0) const;
-    bool cannotAddDiskEncryptionPassword(const CAppliance &comAppliance, QWidget *pParent = 0);
-    void cannotRunUnattendedGuestInstall(const CUnattended &comUnattendedInstall, QWidget *pParent = 0);
-
-    /* API: File-dialog warnings: */
-    bool confirmOverridingFile(const QString &strPath, QWidget *pParent = 0) const;
-    bool confirmOverridingFiles(const QVector<QString> &strPaths, QWidget *pParent = 0) const;
-    bool confirmOverridingFileIfExists(const QString &strPath, QWidget *pParent = 0) const;
-    bool confirmOverridingFilesIfExists(const QVector<QString> &strPaths, QWidget *pParent = 0) const;
+    /** @name VirtualBox Manager / Wizard warnings.
+      * @{ */
+        /// @todo move to notification-center after wizards get theirs.. :)
+        void cannotAcquireHardDiskLocation(const CMedium &comMedium, QWidget *pParent = 0) const;
+        void cannotDeleteHardDiskStorage(const CMedium &medium, const QString &strLocation, QWidget *pParent = 0) const;
+        void cannotDeleteHardDiskStorage(const CProgress &progress, const QString &strLocation, QWidget *pParent = 0) const;
+        void cannotTakeSnapshot(const CMachine &machine, const QString &strMachineName, QWidget *pParent = 0) const;
+        void cannotTakeSnapshot(const CProgress &progress, const QString &strMachineName, QWidget *pParent = 0) const;
+        void cannotFindSnapshotByName(const CMachine &comMachine, const QString &strName, QWidget *pParent = 0) const;
+        bool confirmHardDisklessMachine(QWidget *pParent = 0) const;
+        void cannotCreateMachine(const CVirtualBox &vbox, QWidget *pParent = 0) const;
+        void cannotRegisterMachine(const CVirtualBox &vbox, const QString &strMachineName, QWidget *pParent = 0) const;
+        void cannotOverwriteHardDiskStorage(const QString &strLocation, QWidget *pParent = 0) const;
+        void cannotCreateHardDiskStorage(const CVirtualBox &vbox, const QString &strLocation,QWidget *pParent = 0) const;
+        void cannotCreateHardDiskStorage(const CMedium &medium, const QString &strLocation, QWidget *pParent = 0) const;
+        void cannotCreateHardDiskStorage(const CProgress &progress, const QString &strLocation, QWidget *pParent = 0) const;
+        void cannotCreateHardDiskStorageInFAT(const QString &strLocation, QWidget *pParent = 0) const;
+        void cannotCreateMediumStorage(const CVirtualBox &comVBox, const QString &strLocation, QWidget *pParent = 0) const;
+        void cannotCreateMediumStorage(const CMedium &comMedium, const QString &strLocation, QWidget *pParent = 0) const;
+        void cannotCreateMediumStorage(const CProgress &comProgress, const QString &strLocation, QWidget *pParent = 0) const;
+        void cannotRemoveMachineFolder(const QString &strFolderName, QWidget *pParent = 0) const;
+        void cannotRewriteMachineFolder(const QString &strFolderName, QWidget *pParent = 0) const;
+        void cannotCreateMachineFolder(const QString &strFolderName, QWidget *pParent = 0) const;
+        void cannotCreateAppliance(const CVirtualBox &comVBox, QWidget *pParent = 0) const;
+        void cannotCreateVirtualSystemDescription(const CAppliance &comAppliance, QWidget *pParent = 0) const;
+        void cannotAcquireVirtualSystemDescription(const CAppliance &comAppliance, QWidget *pParent = 0) const;
+        void cannotAddVirtualSystemDescriptionValue(const CVirtualSystemDescription &comDescription, QWidget *pParent = 0) const;
+        void cannotAcquireVirtualSystemDescriptionFormProperty(const CVirtualSystemDescriptionForm &comForm, QWidget *pParent = 0) const;
+        void cannotImportAppliance(CAppliance &appliance, QWidget *pParent = 0) const;
+        void cannotImportAppliance(const CProgress &progress, const QString &strPath, QWidget *pParent = 0) const;
+        bool cannotCheckFiles(const CAppliance &comAppliance, QWidget *pParent = 0) const;
+        bool cannotCheckFiles(const CVFSExplorer &comVFSExplorer, QWidget *pParent = 0) const;
+        bool cannotCheckFiles(const CProgress &comProgress, QWidget *pParent = 0) const;
+        bool cannotRemoveFiles(const CVFSExplorer &comVFSExplorer, QWidget *pParent = 0) const;
+        bool cannotRemoveFiles(const CProgress &comProgress, QWidget *pParent = 0) const;
+        bool confirmExportMachinesInSaveState(const QStringList &machineNames, QWidget *pParent = 0) const;
+        bool cannotExportAppliance(const CAppliance &comAppliance, QWidget *pParent = 0) const;
+        void cannotExportAppliance(const CMachine &machine, const QString &strPath, QWidget *pParent = 0) const;
+        bool cannotExportAppliance(const CProgress &comProgress, const QString &strPath, QWidget *pParent = 0) const;
+        bool cannotAddDiskEncryptionPassword(const CAppliance &comAppliance, QWidget *pParent = 0);
+        void cannotRunUnattendedGuestInstall(const CUnattended &comUnattendedInstall, QWidget *pParent = 0);
+        bool confirmOverridingFile(const QString &strPath, QWidget *pParent = 0) const;
+        bool confirmOverridingFiles(const QVector<QString> &strPaths, QWidget *pParent = 0) const;
+    /** @} */
 
 public slots: