Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVM.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVM.cpp	(revision 91333)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVM.cpp	(revision 91334)
@@ -62,5 +62,5 @@
                                                                                                          comMachine,
                                                                                                          strInstanceName,
-                                                                                                         shortProviderName(),
+                                                                                                         providerShortName(),
                                                                                                          profileName());
         connect(pNotification, &UINotificationProgressCloudMachineAdd::sigCloudMachineAdded,
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVM.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVM.h	(revision 91333)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVM.h	(revision 91334)
@@ -44,7 +44,7 @@
 
     /** Defines @a strProviderShortName. */
-    void setShortProviderName(const QString &strProviderShortName) { m_strProviderShortName = strProviderShortName; }
-    /** Returns short provider name. */
-    QString shortProviderName() const { return m_strProviderShortName; }
+    void setProviderShortName(const QString &strProviderShortName) { m_strProviderShortName = strProviderShortName; }
+    /** Returns provider short name. */
+    QString providerShortName() const { return m_strProviderShortName; }
 
     /** Defines @a strProfileName. */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageExpert.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageExpert.cpp	(revision 91333)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageExpert.cpp	(revision 91334)
@@ -225,12 +225,12 @@
 }
 
-void UIWizardAddCloudVMPageExpert::setShortProviderName(const QString &strProviderShortName)
-{
-    qobject_cast<UIWizardAddCloudVM*>(wizard())->setShortProviderName(strProviderShortName);
-}
-
-QString UIWizardAddCloudVMPageExpert::shortProviderName() const
-{
-    return qobject_cast<UIWizardAddCloudVM*>(wizard())->shortProviderName();
+void UIWizardAddCloudVMPageExpert::setProviderShortName(const QString &strProviderShortName)
+{
+    qobject_cast<UIWizardAddCloudVM*>(wizard())->setProviderShortName(strProviderShortName);
+}
+
+QString UIWizardAddCloudVMPageExpert::providerShortName() const
+{
+    return qobject_cast<UIWizardAddCloudVM*>(wizard())->providerShortName();
 }
 
@@ -268,6 +268,6 @@
 {
     updateComboToolTip(m_pProviderComboBox);
-    setShortProviderName(m_pProviderComboBox->currentData(ProviderData_ShortName).toString());
-    CCloudProvider comCloudProvider = cloudProviderByShortName(shortProviderName(), wizard());
+    setProviderShortName(m_pProviderComboBox->currentData(ProviderData_ShortName).toString());
+    CCloudProvider comCloudProvider = cloudProviderByShortName(providerShortName(), wizard());
     populateProfiles(m_pProfileComboBox, comCloudProvider);
     updateProfile();
@@ -277,5 +277,5 @@
 {
     setProfileName(m_pProfileComboBox->currentData(ProfileData_Name).toString());
-    setClient(cloudClientByName(shortProviderName(), profileName(), wizard()));
+    setClient(cloudClientByName(providerShortName(), profileName(), wizard()));
     populateProfileInstances(m_pSourceInstanceList, client());
     updateSourceInstance();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageExpert.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageExpert.h	(revision 91333)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageExpert.h	(revision 91334)
@@ -68,8 +68,8 @@
 private:
 
-    /** Defines short provider name. */
-    void setShortProviderName(const QString &strProviderShortName);
-    /** Returns profile name. */
-    QString shortProviderName() const;
+    /** Defines provider short name. */
+    void setProviderShortName(const QString &strProviderShortName);
+    /** Returns provider short name. */
+    QString providerShortName() const;
 
     /** Defines profile name. */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageSource.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageSource.cpp	(revision 91333)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageSource.cpp	(revision 91334)
@@ -481,12 +481,12 @@
 }
 
-void UIWizardAddCloudVMPageSource::setShortProviderName(const QString &strProviderShortName)
-{
-    qobject_cast<UIWizardAddCloudVM*>(wizard())->setShortProviderName(strProviderShortName);
-}
-
-QString UIWizardAddCloudVMPageSource::shortProviderName() const
-{
-    return qobject_cast<UIWizardAddCloudVM*>(wizard())->shortProviderName();
+void UIWizardAddCloudVMPageSource::setProviderShortName(const QString &strProviderShortName)
+{
+    qobject_cast<UIWizardAddCloudVM*>(wizard())->setProviderShortName(strProviderShortName);
+}
+
+QString UIWizardAddCloudVMPageSource::providerShortName() const
+{
+    return qobject_cast<UIWizardAddCloudVM*>(wizard())->providerShortName();
 }
 
@@ -524,6 +524,6 @@
 {
     updateComboToolTip(m_pProviderComboBox);
-    setShortProviderName(m_pProviderComboBox->currentData(ProviderData_ShortName).toString());
-    CCloudProvider comCloudProvider = cloudProviderByShortName(shortProviderName(), wizard());
+    setProviderShortName(m_pProviderComboBox->currentData(ProviderData_ShortName).toString());
+    CCloudProvider comCloudProvider = cloudProviderByShortName(providerShortName(), wizard());
     populateProfiles(m_pProfileComboBox, comCloudProvider);
     updateProfile();
@@ -533,5 +533,5 @@
 {
     setProfileName(m_pProfileComboBox->currentData(ProfileData_Name).toString());
-    setClient(cloudClientByName(shortProviderName(), profileName(), wizard()));
+    setClient(cloudClientByName(providerShortName(), profileName(), wizard()));
     populateProfileInstances(m_pSourceInstanceList, client());
     updateSourceInstance();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageSource.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageSource.h	(revision 91333)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageSource.h	(revision 91334)
@@ -107,8 +107,8 @@
 private:
 
-    /** Defines short provider name. */
-    void setShortProviderName(const QString &strProviderShortName);
-    /** Returns profile name. */
-    QString shortProviderName() const;
+    /** Defines provider short name. */
+    void setProviderShortName(const QString &strProviderShortName);
+    /** Returns provider short name. */
+    QString providerShortName() const;
 
     /** Defines profile name. */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVM.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVM.cpp	(revision 91333)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVM.cpp	(revision 91334)
@@ -142,5 +142,5 @@
                                                                                                            comMachine,
                                                                                                            comVSD,
-                                                                                                           shortProviderName(),
+                                                                                                           providerShortName(),
                                                                                                            profileName());
     connect(pNotification, &UINotificationProgressCloudMachineCreate::sigCloudMachineCreated,
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVM.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVM.h	(revision 91333)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVM.h	(revision 91334)
@@ -55,7 +55,7 @@
 
     /** Defines @a strProviderShortName. */
-    void setShortProviderName(const QString &strProviderShortName) { m_strProviderShortName = strProviderShortName; }
-    /** Returns short provider name. */
-    QString shortProviderName() const { return m_strProviderShortName; }
+    void setProviderShortName(const QString &strProviderShortName) { m_strProviderShortName = strProviderShortName; }
+    /** Returns provider short name. */
+    QString providerShortName() const { return m_strProviderShortName; }
 
     /** Defines @a strProfileName. */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageExpert.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageExpert.cpp	(revision 91333)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageExpert.cpp	(revision 91334)
@@ -356,12 +356,12 @@
 }
 
-void UIWizardNewCloudVMPageExpert::setShortProviderName(const QString &strProviderShortName)
-{
-    qobject_cast<UIWizardNewCloudVM*>(wizard())->setShortProviderName(strProviderShortName);
-}
-
-QString UIWizardNewCloudVMPageExpert::shortProviderName() const
-{
-    return qobject_cast<UIWizardNewCloudVM*>(wizard())->shortProviderName();
+void UIWizardNewCloudVMPageExpert::setProviderShortName(const QString &strProviderShortName)
+{
+    qobject_cast<UIWizardNewCloudVM*>(wizard())->setProviderShortName(strProviderShortName);
+}
+
+QString UIWizardNewCloudVMPageExpert::providerShortName() const
+{
+    return qobject_cast<UIWizardNewCloudVM*>(wizard())->providerShortName();
 }
 
@@ -409,6 +409,6 @@
 {
     updateComboToolTip(m_pProviderComboBox);
-    setShortProviderName(m_pProviderComboBox->currentData(ProviderData_ShortName).toString());
-    CCloudProvider comCloudProvider = cloudProviderByShortName(shortProviderName(), wizard());
+    setProviderShortName(m_pProviderComboBox->currentData(ProviderData_ShortName).toString());
+    CCloudProvider comCloudProvider = cloudProviderByShortName(providerShortName(), wizard());
     populateProfiles(m_pProfileComboBox, comCloudProvider);
     updateProfile();
@@ -418,5 +418,5 @@
 {
     setProfileName(m_pProfileComboBox->currentData(ProfileData_Name).toString());
-    setClient(cloudClientByName(shortProviderName(), profileName(), wizard()));
+    setClient(cloudClientByName(providerShortName(), profileName(), wizard()));
     updateSource();
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageExpert.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageExpert.h	(revision 91333)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageExpert.h	(revision 91334)
@@ -75,8 +75,8 @@
 private:
 
-    /** Defines short provider name. */
-    void setShortProviderName(const QString &strProviderShortName);
-    /** Returns profile name. */
-    QString shortProviderName() const;
+    /** Defines provider short name. */
+    void setProviderShortName(const QString &strProviderShortName);
+    /** Returns provider short name. */
+    QString providerShortName() const;
 
     /** Defines profile name. */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageSource.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageSource.cpp	(revision 91333)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageSource.cpp	(revision 91334)
@@ -556,12 +556,12 @@
 }
 
-void UIWizardNewCloudVMPageSource::setShortProviderName(const QString &strProviderShortName)
-{
-    qobject_cast<UIWizardNewCloudVM*>(wizard())->setShortProviderName(strProviderShortName);
-}
-
-QString UIWizardNewCloudVMPageSource::shortProviderName() const
-{
-    return qobject_cast<UIWizardNewCloudVM*>(wizard())->shortProviderName();
+void UIWizardNewCloudVMPageSource::setProviderShortName(const QString &strProviderShortName)
+{
+    qobject_cast<UIWizardNewCloudVM*>(wizard())->setProviderShortName(strProviderShortName);
+}
+
+QString UIWizardNewCloudVMPageSource::providerShortName() const
+{
+    return qobject_cast<UIWizardNewCloudVM*>(wizard())->providerShortName();
 }
 
@@ -604,6 +604,6 @@
 {
     updateComboToolTip(m_pProviderComboBox);
-    setShortProviderName(m_pProviderComboBox->currentData(ProviderData_ShortName).toString());
-    CCloudProvider comCloudProvider = cloudProviderByShortName(shortProviderName(), wizard());
+    setProviderShortName(m_pProviderComboBox->currentData(ProviderData_ShortName).toString());
+    CCloudProvider comCloudProvider = cloudProviderByShortName(providerShortName(), wizard());
     populateProfiles(m_pProfileComboBox, comCloudProvider);
     updateProfile();
@@ -613,5 +613,5 @@
 {
     setProfileName(m_pProfileComboBox->currentData(ProfileData_Name).toString());
-    setClient(cloudClientByName(shortProviderName(), profileName(), wizard()));
+    setClient(cloudClientByName(providerShortName(), profileName(), wizard()));
     updateSource();
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageSource.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageSource.h	(revision 91333)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageSource.h	(revision 91334)
@@ -116,8 +116,8 @@
 private:
 
-    /** Defines short provider name. */
-    void setShortProviderName(const QString &strProviderShortName);
-    /** Returns profile name. */
-    QString shortProviderName() const;
+    /** Defines provider short name. */
+    void setProviderShortName(const QString &strProviderShortName);
+    /** Returns provider short name. */
+    QString providerShortName() const;
 
     /** Defines profile name. */