Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVM.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVM.cpp	(revision 91334)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVM.cpp	(revision 91335)
@@ -32,5 +32,4 @@
                                        const QString &strFullGroupName /* = QString() */)
     : UINativeWizard(pParent, WizardType_AddCloudVM, WizardMode_Auto)
-    , m_strFullGroupName(strFullGroupName)
 {
 #ifndef VBOX_WS_MAC
@@ -41,4 +40,13 @@
     setPixmapName(":/wizard_new_cloud_vm_bg.png");
 #endif
+
+    /* Parse passed full group name: */
+    const QString strProviderShortName = strFullGroupName.section('/', 1, 1);
+    const QString strProfileName = strFullGroupName.section('/', 2, 2);
+    if (!strProviderShortName.isEmpty() && !strProfileName.isEmpty())
+    {
+        m_strProviderShortName = strProviderShortName;
+        m_strProfileName = strProfileName;
+    }
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVM.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVM.h	(revision 91334)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVM.h	(revision 91335)
@@ -40,7 +40,4 @@
     UIWizardAddCloudVM(QWidget *pParent, const QString &strFullGroupName = QString());
 
-    /** Returns full group name. */
-    QString fullGroupName() const { return m_strFullGroupName; }
-
     /** Defines @a strProviderShortName. */
     void setProviderShortName(const QString &strProviderShortName) { m_strProviderShortName = strProviderShortName; }
@@ -76,6 +73,4 @@
 private:
 
-    /** Holds the full group name (/provider/profile) to add VM to. */
-    QString       m_strFullGroupName;
     /** Holds the short provider name. */
     QString       m_strProviderShortName;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageExpert.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageExpert.cpp	(revision 91334)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageExpert.cpp	(revision 91335)
@@ -269,6 +269,5 @@
     updateComboToolTip(m_pProviderComboBox);
     setProviderShortName(m_pProviderComboBox->currentData(ProviderData_ShortName).toString());
-    CCloudProvider comCloudProvider = cloudProviderByShortName(providerShortName(), wizard());
-    populateProfiles(m_pProfileComboBox, comCloudProvider);
+    populateProfiles(m_pProfileComboBox, providerShortName(), profileName());
     updateProfile();
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageSource.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageSource.cpp	(revision 91334)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageSource.cpp	(revision 91335)
@@ -104,12 +104,16 @@
 }
 
-void UIWizardAddCloudVMPage1::populateProfiles(QIComboBox *pCombo, const CCloudProvider &comProvider)
+void UIWizardAddCloudVMPage1::populateProfiles(QIComboBox *pCombo,
+                                               const QString &strProviderShortName,
+                                               const QString &strProfileName)
 {
     /* Sanity check: */
     AssertPtrReturnVoid(pCombo);
-    AssertReturnVoid(comProvider.isNotNull());
     /* We need top-level parent as well: */
     QWidget *pParent = pCombo->window();
     AssertPtrReturnVoid(pParent);
+    /* Acquire provider: */
+    CCloudProvider comProvider = cloudProviderByShortName(strProviderShortName, pParent);
+    AssertReturnVoid(comProvider.isNotNull());
 
     /* Block signals while updating: */
@@ -120,14 +124,6 @@
     if (pCombo->currentIndex() != -1)
         strOldData = pCombo->itemData(pCombo->currentIndex(), ProfileData_Name).toString();
-    else
-    {
-        /* Try to fetch "old" profile name from wizard full group name: */
-        UIWizardAddCloudVM *pWizard = qobject_cast<UIWizardAddCloudVM*>(pParent);
-        AssertPtrReturnVoid(pWizard);
-        const QString strFullGroupName = pWizard->fullGroupName();
-        const QString strProfileName = strFullGroupName.section('/', 2, 2);
-        if (!strProfileName.isEmpty())
-            strOldData = strProfileName;
-    }
+    else if (!strProfileName.isEmpty())
+        strOldData = strProfileName;
 
     /* Clear combo initially: */
@@ -140,12 +136,12 @@
         if (comProfile.isNull())
             continue;
-        /* Acquire profile name: */
-        QString strProfileName;
-        if (!cloudProfileName(comProfile, strProfileName, pParent))
+        /* Acquire current profile name: */
+        QString strCurrentProfileName;
+        if (!cloudProfileName(comProfile, strCurrentProfileName, pParent))
             continue;
 
         /* Compose item, fill the data: */
-        pCombo->addItem(strProfileName);
-        pCombo->setItemData(pCombo->count() - 1, strProfileName, ProfileData_Name);
+        pCombo->addItem(strCurrentProfileName);
+        pCombo->setItemData(pCombo->count() - 1, strCurrentProfileName, ProfileData_Name);
     }
 
@@ -525,6 +521,5 @@
     updateComboToolTip(m_pProviderComboBox);
     setProviderShortName(m_pProviderComboBox->currentData(ProviderData_ShortName).toString());
-    CCloudProvider comCloudProvider = cloudProviderByShortName(providerShortName(), wizard());
-    populateProfiles(m_pProfileComboBox, comCloudProvider);
+    populateProfiles(m_pProfileComboBox, providerShortName(), profileName());
     updateProfile();
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageSource.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageSource.h	(revision 91334)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageSource.h	(revision 91335)
@@ -55,6 +55,8 @@
     /** Populates @a pCombo with known providers. */
     void populateProviders(QIComboBox *pCombo);
-    /** Populates @a pCombo with known profiles of @a comProvider specified. */
-    void populateProfiles(QIComboBox *pCombo, const CCloudProvider &comProvider);
+    /** Populates @a pCombo with known profiles.
+      * @param  strProviderShortName  Brings the short name of provider profiles related to.
+      * @param  strProfileName        Brings the name of profile to be chosen by default. */
+    void populateProfiles(QIComboBox *pCombo, const QString &strProviderShortName, const QString &strProfileName);
     /** Populates @a pList with profile instances available in @a comClient. */
     void populateProfileInstances(QListWidget *pList, const CCloudClient &comClient);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVM.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVM.cpp	(revision 91334)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVM.cpp	(revision 91335)
@@ -40,5 +40,4 @@
                                        WizardMode enmMode /* = WizardMode_Auto */)
     : UINativeWizard(pParent, WizardType_NewCloudVM, enmMode)
-    , m_strFullGroupName(strFullGroupName)
     , m_comClient(comClient)
     , m_comVSD(comVSD)
@@ -53,4 +52,13 @@
     setPixmapName(":/wizard_new_cloud_vm_bg.png");
 #endif
+
+    /* Parse passed full group name: */
+    const QString strProviderShortName = strFullGroupName.section('/', 1, 1);
+    const QString strProfileName = strFullGroupName.section('/', 2, 2);
+    if (!strProviderShortName.isEmpty() && !strProfileName.isEmpty())
+    {
+        m_strProviderShortName = strProviderShortName;
+        m_strProfileName = strProfileName;
+    }
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVM.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVM.h	(revision 91334)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVM.h	(revision 91335)
@@ -51,7 +51,4 @@
     void setFinalStepPrevented(bool fPrevented) { m_fFinalStepPrevented = fPrevented; }
 
-    /** Returns full group name. */
-    QString fullGroupName() const { return m_strFullGroupName; }
-
     /** Defines @a strProviderShortName. */
     void setProviderShortName(const QString &strProviderShortName) { m_strProviderShortName = strProviderShortName; }
@@ -104,6 +101,4 @@
 private:
 
-    /** Holds the full group name (/provider/profile) to add VM to. */
-    QString                        m_strFullGroupName;
     /** Holds the short provider name. */
     QString                        m_strProviderShortName;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageExpert.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageExpert.cpp	(revision 91334)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageExpert.cpp	(revision 91335)
@@ -410,6 +410,5 @@
     updateComboToolTip(m_pProviderComboBox);
     setProviderShortName(m_pProviderComboBox->currentData(ProviderData_ShortName).toString());
-    CCloudProvider comCloudProvider = cloudProviderByShortName(providerShortName(), wizard());
-    populateProfiles(m_pProfileComboBox, comCloudProvider);
+    populateProfiles(m_pProfileComboBox, providerShortName(), profileName());
     updateProfile();
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageSource.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageSource.cpp	(revision 91334)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageSource.cpp	(revision 91335)
@@ -107,12 +107,16 @@
 }
 
-void UIWizardNewCloudVMPage1::populateProfiles(QIComboBox *pCombo, const CCloudProvider &comProvider)
+void UIWizardNewCloudVMPage1::populateProfiles(QIComboBox *pCombo,
+                                               const QString &strProviderShortName,
+                                               const QString &strProfileName)
 {
     /* Sanity check: */
     AssertPtrReturnVoid(pCombo);
-    AssertReturnVoid(comProvider.isNotNull());
     /* We need top-level parent as well: */
     QWidget *pParent = pCombo->window();
     AssertPtrReturnVoid(pParent);
+    /* Acquire provider: */
+    CCloudProvider comProvider = cloudProviderByShortName(strProviderShortName, pParent);
+    AssertReturnVoid(comProvider.isNotNull());
 
     /* Block signals while updating: */
@@ -123,14 +127,6 @@
     if (pCombo->currentIndex() != -1)
         strOldData = pCombo->itemData(pCombo->currentIndex(), ProfileData_Name).toString();
-    else
-    {
-        /* Try to fetch "old" profile name from wizard full group name: */
-        UIWizardNewCloudVM *pWizard = qobject_cast<UIWizardNewCloudVM*>(pParent);
-        AssertPtrReturnVoid(pWizard);
-        const QString strFullGroupName = pWizard->fullGroupName();
-        const QString strProfileName = strFullGroupName.section('/', 2, 2);
-        if (!strProfileName.isEmpty())
-            strOldData = strProfileName;
-    }
+    else if (!strProfileName.isEmpty())
+        strOldData = strProfileName;
 
     /* Clear combo initially: */
@@ -143,12 +139,12 @@
         if (comProfile.isNull())
             continue;
-        /* Acquire profile name: */
-        QString strProfileName;
-        if (!cloudProfileName(comProfile, strProfileName, pParent))
+        /* Acquire current profile name: */
+        QString strCurrentProfileName;
+        if (!cloudProfileName(comProfile, strCurrentProfileName, pParent))
             continue;
 
         /* Compose item, fill the data: */
-        pCombo->addItem(strProfileName);
-        pCombo->setItemData(pCombo->count() - 1, strProfileName, ProfileData_Name);
+        pCombo->addItem(strCurrentProfileName);
+        pCombo->setItemData(pCombo->count() - 1, strCurrentProfileName, ProfileData_Name);
     }
 
@@ -605,6 +601,5 @@
     updateComboToolTip(m_pProviderComboBox);
     setProviderShortName(m_pProviderComboBox->currentData(ProviderData_ShortName).toString());
-    CCloudProvider comCloudProvider = cloudProviderByShortName(providerShortName(), wizard());
-    populateProfiles(m_pProfileComboBox, comCloudProvider);
+    populateProfiles(m_pProfileComboBox, providerShortName(), profileName());
     updateProfile();
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageSource.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageSource.h	(revision 91334)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageSource.h	(revision 91335)
@@ -59,6 +59,8 @@
     /** Populates @a pCombo with known providers. */
     void populateProviders(QIComboBox *pCombo);
-    /** Populates @a pCombo with known profiles of @a comProvider specified. */
-    void populateProfiles(QIComboBox *pCombo, const CCloudProvider &comProvider);
+    /** Populates @a pCombo with known profiles.
+      * @param  strProviderShortName  Brings the short name of provider profiles related to.
+      * @param  strProfileName        Brings the name of profile to be chosen by default. */
+    void populateProfiles(QIComboBox *pCombo, const QString &strProviderShortName, const QString &strProfileName);
     /** Populates @a pList with source images from tab of @a pTabBar available in @a comClient. */
     void populateSourceImages(QListWidget *pList, QTabBar *pTabBar, const CCloudClient &comClient);